<?php

/**
 * ECOM - Configuration file
 *
 * @package bt_ecom
 * @version 1.0
 * @copyright BonusThemes.com 2008
 * @link http://www.bonusthemes.com/goto/bt_ecom
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

global $tpl_config;
$tpl_config = array();
$tpl_config['component'] = array();


// CONFIGURATION START ////////////////////////////////////////////////////////

/**
 *  CSC Default Control
 *
 *  @type list
 *  @values 0, 1
 *  @default 0
 */
$tpl_config['default'] = 0;

$tpl_config['component']['*'] = array(

	/**
	 *  Page width
	 *
	 *  Width of entire page (in pixels)
	 *
	 *  @type integer
	 *  @default 960
	 */
	'width' => 960,

	/**
	 *  Show pathway
	 *
	 *  Set to 'never' if you want the pathway to remain hidden,
	 *  'content' if you want to see the pathway on the content
	 *  pages except the front-page, 'always' if you want the
	 *  pathway to be visible at all times
	 *
	 *  @type list
	 *  @values never, content, always
	 *  @default content
	 */
	'pathway' => 'content',

	/**
	 *  BT Logo
	 *
	 *  Shows or hides the BonusThemes logo
	 *
	 *  @type radio
	 *  @values on, off
	 *  @default on
	 */
	'btlogo' => 'on',

	/**
	 *  Header Menu Type
	 *
	 *  Enables the default menu on the top of the page or position header.
	 *
	 *  @type radio
	 *  @values menu, header
	 *  @default menu
	 */
	'header_menu' => 'menu',

	/**
	 *  Header menu name
	 *
	 *  Name of the Joomla menu that will be used as source for the menu on the page header.
	 *
	 *  @type menu
	 *  @default topmenu
	 */
	'header_menu_name' => 'topmenu',

	/**
	 *  SEOCP
	 *
	 *  Enable SEOCP (Search Engine Optimized Content Positioning)
	 *  to position put the content of your website in the start
	 *  of the HTML content. This helps search engines find and
	 *  analyse the content easier. On the downside if SEOCP is
	 *  enabled users who disabled the JavaScript engine of their
	 *  browser will not be able to see the page's  main content.
	 *
	 *  @type radio
	 *  @values on, off
	 *  @default off
	 */
	'seocp' => 'off',

	/**
	 *  Gap size
	 *
	 *  Width (in pixels) of gap between positions and main content
	 *
	 *  @type integer
	 *  @default 200
	 */
	'gap' => 4,

	/**
	 *  Width of position icon
	 *
	 *  Width (in pixels) of position icon
	 *
	 *  @type integer
	 *  @default 200
	 */
	'pos_icon_width' => 200,

	/**
	 *  Width of position left
	 *
	 *  Width (in pixels) of position left
	 *
	 *  @type integer
	 *  @default 300
	 */
	'pos_left_width' => 300,

	/**
	 *  Width of position user1
	 *
	 *  Width (in pixels) of position user1
	 *
	 *  @type integer
	 *  @default 100
	 */
	'pos_user1_width' => 100,

	/**
	 *  Width of position user2
	 *
	 *  Width (in pixels) of position user2
	 *
	 *  @type integer
	 *  @default 100
	 */
	'pos_user2_width' => 100,

	/**
	 *  Width of position right
	 *
	 *  Width (in pixels) of position right
	 *
	 *  @type integer
	 *  @default 400
	 */
	'pos_right_width' => 400,

	/**
	 *  Width of position user3
	 *
	 *  Width (in pixels) of position user3
	 *
	 *  @type integer
	 *  @default 150
	 */
	'pos_user3_width' => 150,

	/**
	 *  Width of position user4
	 *
	 *  Width (in pixels) of position user4
	 *
	 *  @type integer
	 *  @default 150
	 */
	'pos_user4_width' => 150,

);

// CONFIGURATION END //////////////////////////////////////////////////////////

?>