<?php

/**
 * ECOM - Joomla Template
 *
 * @package bt_ecom
 * @version 1.0
 * @copyright BonusThemes.com 2008
 * @link http://www.bonusthemes.com/goto/bt_ecom
 */

defined('_VALID_MOS') or die('Restricted access');


class TplBtEcom
{
	var $width = 960;
	var $gap = 4;

	var $pathway = 'content';
	var $btlogo = 'on';

	var $header_menu = 'menu';
	var $header_menu_name = 'topmenu';

	var $seocp = 'off';

	function TplBtEcom()
	{
		$this->__construct();
	}

	function __construct()
	{
		$this->prepare_parameters();
		$this->prepare_path();
		$this->prepare_pathway();

		$this->lshow = strtolower($this->btlogo) == 'on';

		$this->seocp = strtolower($this->seocp) == 'on';

		$this->show_menu = $this->header_menu == 'menu';

		if ($this->show_menu)
			$this->load_menu($this->header_menu_name);

		// calculate widths
		$this->css_fixed_widths = '';
		foreach (array('left', 'right', 'user1', 'user2', 'user3', 'user4') as $p1) {
			$p2 = 'pos_' . $p1 . '_width';
			if (!isset($this->$p2))
				$this->$p2 = 0;
		}

		$this->left_width = $this->canonicalize_widths('left', 'user1', 'user2');
		$this->right_width = $this->canonicalize_widths('right', 'user3', 'user4');

		$this->main_width = $this->width - 16; // 16 = #cnt total margin
		if ($this->modcount('left') || $this->modcount('user1') || $this->modcount('user2'))
			$this->main_width -= $this->left_width + $this->gap;
		if ($this->modcount('right') || $this->modcount('user3') || $this->modcount('user4'))
			$this->main_width -= $this->right_width + $this->gap;

		$this->main_inner_width = $this->main_width - 20; // 20 = total content padding
	}

	function canonicalize_widths($top, $left, $right)
	{
		$width = 0;

		$pos_top_width = 'pos_' . $top . '_width';
		$pos_left_width = 'pos_' . $left . '_width';
		$pos_right_width = 'pos_' . $right . '_width';

		if (($this->modcount($left) && $this->$pos_left_width) || ($this->modcount($right) && $this->$pos_right_width)) {
			if ($this->modcount($left))
				$width += $this->$pos_left_width;

			if ($this->modcount($left) && $this->modcount($right))
				$width += $this->gap;

			if ($this->modcount($right))
				$width += $this->$pos_right_width;
		}

		if ($this->modcount($top) && $this->$pos_top_width > $width)
			$width = $this->$pos_top_width;

		if ($width == 0)
			$width = 100;

		if ($width > $this->$pos_top_width)
			$this->$pos_top_width = $width;

		if ($this->modcount($left) && $this->modcount($right) && $this->$pos_left_width == 0 && $this->$pos_right_width == 0) {
			$this->$pos_left_width = round(($width - $this->gap) / 2);
			$this->$pos_right_width = $width - $this->$pos_left_width - $this->gap;
		}
		else if ($this->modcount($left) && $this->$pos_left_width == 0) {
			$this->$pos_left_width = $width - $this->$pos_right_width - $this->gap;
		}
		else if ($this->modcount($right) && $this->$pos_right_width == 0) {
			$this->$pos_right_width = $width - $this->$pos_left_width - $this->gap;
		}

		$styles = array('-style1', '-style2', '-style3');
		$styles_str = '';
		foreach ($styles as $style) {
			if ($styles_str != '')
				$styles_str .= ', ';

			$styles_str .= '# .module' . $style . ' div';
		}

		if ($this->$pos_top_width > 0)
			$this->css_fixed_widths .= str_replace('#', '#pos_' . $top, $styles_str) . ' { width: ' . $this->$pos_top_width . 'px; }' . "\n";

		if ($this->$pos_left_width > 0)
			$this->css_fixed_widths .= str_replace('#', '#pos_' . $left, $styles_str) . ' { width: ' . $this->$pos_left_width . 'px; }' . "\n";

		if ($this->$pos_right_width > 0)
			$this->css_fixed_widths .= str_replace('#', '#pos_' . $right, $styles_str) . ' { width: ' . $this->$pos_right_width . 'px; }' . "\n";

		return $width;
	}

	function prepare_parameters()
	{
		global $tpl_config, $option;

		$params = @$tpl_config['component']['*'];
		if (!is_array($params))
			$params = array();

		if (!empty($tpl_config['component'][$option]))
			$params = array_merge($params, $tpl_config['component'][$option]);

		$vars = get_class_vars(get_class($this));
		foreach ($params as $k => $v)
			if (array_key_exists($k, $vars) || preg_match('/^pos_[a-z]+_width$/', $k))
				$this->$k = $v;
	}

	function prepare_path()
	{
		$this->path = $GLOBALS['mosConfig_live_site'] . '/templates/' . $GLOBALS['mainframe']->getTemplate();
	}

	function prepare_pathway()
	{
		switch ($this->pathway) {
			case 'never':
				$this->pathway = FALSE;
				break;

			case 'always':
				$this->pathway = TRUE;
				break;

			case 'content':
			default:
				$this->pathway = $GLOBALS['Itemid'] != 1;
		}
	}

	function modcount($position_name)
	{
		static $modules = array();

		if (!isset($modules[$position_name]))
			$modules[$position_name] = mosCountModules($position_name);

		return $modules[$position_name];
	}

	function echo_hidden_position($position_name)
	{
		if ($this->modcount($position_name)) {
			echo '<div id="pos_' . $position_name . '" style="display:none">' . "\n";
			mosLoadModules($position_name, -2);
			echo '</div>' . "\n";
		}
	}

	function echo_position($position_name)
	{
		if ($this->modcount($position_name)) {
			$var = 'pos_' . $position_name . '_width';
			printf(
				'<div id="pos_%s"%s>' . "\n",
				$position_name,
				isset($this->$var) && !empty($this->$var) ? ' style="width:' . $this->$var . 'px"' : ''
			);
			mosLoadModules($position_name, -3);
			echo '</div>' . "\n";
			echo '<div class="clearfix"></div>' . "\n"; // fix for IE7
		}
	}

	function echo_positions()
	{
		// arguments: first is the spacer name, the rest are position names
		$args = func_get_args();
		$count = count($args);
		if ($count < 2)
			die('Error in echo_positions(): Not enough arguments');

		$positions = array();
		for ($i = 1; $i < $count; $i++)
			if ($this->modcount($args[$i]))
				$positions[] = $args[$i];

		if (empty($positions))
			return;

		if ($count > 2)
			echo '<table cellspacing="0" cellpadding="0" width="100%"><tr>' . "\n";

		$first = TRUE;
		foreach ($positions as $position_name) {
			if ($first)
				$first = FALSE;
			else
				echo '<td class="gap"></td>' . "\n";

			if ($count > 2)
				echo '<td valign="top">' . "\n";

			$this->echo_position($position_name);

			if ($count > 2)
				echo '</td>' . "\n";
		}

		if ($count > 2)
			echo '</tr></table>' . "\n";

		// output spacer
		if (!empty($args[0]))
			echo '<div id="' . $args[0] . '"></div>' . "\n";
	}

	function load_menu($menu_name)
	{
		global $mosConfig_shownoauth, $database, $my;

		// load menu
		$database->setQuery( sprintf(
			"SELECT * FROM #__menu WHERE menutype=%s AND published='1' %s ORDER BY ordering",
			$database->Quote($menu_name),
			$mosConfig_shownoauth ? "" : "AND access <= '$my->gid'"
		) );
		$menu = $database->loadObjectList('id');

		// initialize menu tree
		$menu_base = array();
		foreach ($menu as $k => $mitem) {
			$mi = $this->load_menu_item($mitem);
			$menu[$k]->is_active = $mi['selection'] > 0;
			$menu[$k]->selection = $mi['selection'];
			$menu[$k]->type = $mi['type'];
			$menu[$k]->link = $mi['link'];
			$menu[$k]->href = $mi['href'];
			$menu[$k]->name = $mi['name'];
			$menu[$k]->image = $mi['image'];
			$menu[$k]->sub_menu_items = array();
		}

		// set tree hierarchy
		foreach ($menu as $k => $mitem) {
			if ($mitem->parent == 0)
				$menu_base[] = $k;
			else if (isset($menu[$mitem->parent]))
				$menu[$mitem->parent]->sub_menu_items[] = $k;
		}

		// prepare javascript code
		$this->menu_head_tags = array();
		$this->menu_js = '';
		if (!empty($menu_base)) {
			$stack = array('base' => $menu_base);
			while (!empty($stack)) {
				reset($stack);
				list($base, $items) = each($stack);
				array_shift($stack);

				foreach ($items as $item) {
					$mi = &$menu[$item];

					if (!empty($mi->sub_menu_items))
						$stack = array_merge($stack, array('cmi' . $item => $mi->sub_menu_items));

					if ($base == 'base') {
						$mi->head_id = 'cmi' . $item;
						$mi->full_link = $mi->href != '' ? '<a ' . $mi->href . '>' . $mi->name . '</a>' : $mi->name;
						$this->menu_head_tags[] = $mi;
						$this->menu_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', type: '%s', link: '%s', selection: %u});\n",
							'cmi' . $item,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							$mi->selection
						);
					}
					else {
						$this->menu_js .= sprintf(
							"document['cmenu_items'].push({id: '%s', parent_id: '%s', type: '%s', link: '%s', caption: '%s', selection: %u});\n",
							'cmi' . $item,
							$base,
							json_esc($mi->type),
							json_esc(str_replace('&amp;', '&', $mi->link)),
							json_esc(str_replace('&amp;', '&', $mi->name)),
							$mi->selection
						);
					}
				}	
			}
		}

	}

	function load_menu_item($mitem)
	{
		$result = array(
			'type' => 'text', // text, link, link_new, link_popup, separator
			'name' => '',
			'link' => '',
			'href' => '',
			'image' => '',
			'selection' => 0, // 0 = none, 1 = parent, 2 = current
		);

		// returns true if item is active

		global $Itemid, $mosConfig_live_site, $mainframe;

		switch ($mitem->type) {
			case 'separator':
				$result['type'] = 'separator';
				break;

			case 'component_item_link':
				break;
				
			case 'url':
				if ( eregi( 'index.php\?', $mitem->link ) && !eregi( 'http', $mitem->link ) && !eregi( 'https', $mitem->link ) ) {
					if ( !eregi( 'Itemid=', $mitem->link ) ) {
						$mitem->link .= '&Itemid='. $mitem->id;
					}
				}
				break;
				
			case 'content_item_link':
			case 'content_typed':
				// load menu params
				$menuparams = new mosParameters( $mitem->params, $mainframe->getPath( 'menu_xml', $mitem->type ), 'menu' );
				
				$unique_itemid = $menuparams->get( 'unique_itemid', 1 );
				
				if ( $unique_itemid ) {
					$mitem->link .= '&Itemid='. $mitem->id;
				} else {
					$temp = split('&task=view&id=', $mitem->link);
					
					if ( $mitem->type == 'content_typed' ) {
						$mitem->link .= '&Itemid='. $mainframe->getItemid($temp[1], 1, 0);
					} else {
						$mitem->link .= '&Itemid='. $mainframe->getItemid($temp[1], 0, 1);
					}
				}
				break;

			default:
				$mitem->link .= '&Itemid='. $mitem->id;
				break;
		}

		// Active Menu highlighting
		$mitem->is_active = $Itemid == $mitem->id;

		// support for `active_menu` of 'Link - Component Item'	
		if ( !$mitem->is_active && $mitem->type == 'component_item_link' ) {
			parse_str( $mitem->link, $url );
			$mitem->is_active = $url['Itemid'] == $Itemid;
		}
		
		// support for `active_menu` of 'Link - Url' if link is relative
		if ( !$mitem->is_active /*&& $mitem->type == 'url'*/ && strpos( 'http', $mitem->link ) === false) {
			parse_str( $mitem->link, $url );
			$mitem->is_active = isset( $url['Itemid'] ) && $url['Itemid'] == $Itemid;
		}

		// support for url matches
		if (!$mitem->is_active) {
			if (isset($_SERVER['REQUEST_URI'])) {
				$this_uri = $_SERVER['REQUEST_URI'];
			}
			else {
				$this_uri = $_SERVER['PHP_SELF'];

				if ($this_uri == '' || $this_uri == '/')
					$this_uri = '/index.php';

				if (isset($_SERVER['QUERY_STRING'])) {
					$this_uri .= '?' . $_SERVER['QUERY_STRING'];
				}
				else if (!empty($_GET)) {
					$get_str = array();
					foreach ($_GET as $k => $v)
						$get_str[] = $k . '=' . urlencode($v);
					$this_uri .= '?' . implode('&', $get_str);
				}
			}
			$this_uri = preg_replace('~^[\w/._-]*(/index.php\??)~', '\\1', $this_uri);


			$link = $mitem->link;
			if (substr($link, 0, 4) == 'http') {
				global $mosConfig_live_site;
				if (substr($link, 0, strlen($mosConfig_live_site)) == $mosConfig_live_site)
					$link = substr($link, strlen($mosConfig_live_site));
			}
			else if (substr($link, 0, 9) == 'index.php') {
				$link = '/' . $link;
			}

			$mitem->is_active = $this_uri == $link;
		}

		// replace & with amp; for xhtml compliance
		$mitem->link = ampReplace( $mitem->link );

		// run through SEF convertor
		$mitem->link = sefRelToAbs( $mitem->link );

		// replace & with amp; for xhtml compliance
		// remove slashes from excaped characters
		$result['name'] = stripslashes( ampReplace($mitem->name) );

		$result['selection'] = $mitem->is_active ? 1 : 0;

		$result['link'] = $mitem->link;

		switch ($mitem->browserNav) {
			// cases are slightly different
			case 1:
				// open in a new window
				$result['href'] = 'href="'. $mitem->link .'" target="_blank" ';
				$result['type'] = 'link_new';
				break;

			case 2:
				// open in a popup window
				$result['href'] = "href=\"javascript:void(0)\" onclick=\"popup('{$mitem->link}')\" ";
				$result['type'] = 'link_popup';
				break;

			case 3:
				// don't link it
				$result['link'] = '';
				break;

			default:	
				// open in parent window
				$result['href'] = 'href="'. $mitem->link .'" ';
				$result['type'] = 'link';
				break;
		}

		// retrieve image
		$menu_params = new stdClass();
		$menu_params = new mosParameters($mitem->params);
		$menu_image = $menu_params->def('menu_image', -1);
		$result['image'] = $menu_image != '-1' && $menu_image ? $mosConfig_live_site .'/images/stories/'. $menu_image : '';

		return $result;
	}

}


/**
 * Escapes strings to be used by JavaScript
 * 
 * @version 1.1.0.20070709
 * @author Alex Stylianos
 * @copyright Creative Pulse 2007
 * @link http://www.creativepulse.eu
 */
function json_esc($input, $esc_lt_gt = true)
{
	$result = '';
	$input = (string) $input;
	$conv = array( "'" => "'", '"' => '"', '&' => '&', '\\' => '\\', "\n" => 'n', "\r" => 'r', "\t" => 't', "\b" => 'b', "\f" => 'f' );

	if ($esc_lt_gt)
		$conv = array_merge($conv, array( '<' => 'u003C', '>' => 'u003E' ));

	for ($i = 0, $len = strlen($input); $i < $len; $i++)
		$result .= isset($conv[$input[$i]]) ? '\\' . $conv[$input[$i]] : $input[$i];

	return $result;
} 

?>